# Copyright (C) 2006-2009 Craciun Dan
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA

Xchat::register("XNP", "0.8.4", "XChat Now Playing Script for Amarok 1.4");

Xchat::hook_command("TOGGLE_ALBUM", call_toggle_album);
Xchat::hook_command("TOGGLE_YEAR", call_toggle_year);
Xchat::hook_command("TOGGLE_TRACK", call_toggle_track);
Xchat::hook_command("TOGGLE_LENGTH", call_toggle_length);
Xchat::hook_command("TOGGLE_BITRATE", call_toggle_bitrate);
Xchat::hook_command("TOGGLE_SIZE", call_toggle_size);
Xchat::hook_command("TOGGLE_SHOW_MENU", call_toggle_show_menu);
Xchat::hook_command("BROWSER1", call_browser1);
Xchat::hook_command("BROWSER2", call_browser2);
Xchat::hook_command("BROWSER3", call_browser3);
Xchat::hook_command("BROWSER4", call_browser4);

Xchat::hook_command("XNPMUTE", cmd_xnpmute);
Xchat::hook_command("XNPVOL1", cmd_xnpvol1);
Xchat::hook_command("XNPVOL2", cmd_xnpvol2);
Xchat::hook_command("XNPVOL3", cmd_xnpvol3);
Xchat::hook_command("XNPVOL4", cmd_xnpvol4);
Xchat::hook_command("XNPVOL5", cmd_xnpvol5);
Xchat::hook_command("XNPVOL6", cmd_xnpvol6);
Xchat::hook_command("XNPVOL7", cmd_xnpvol7);
Xchat::hook_command("XNPVOL8", cmd_xnpvol8);
Xchat::hook_command("XNPVOL9", cmd_xnpvol9);
Xchat::hook_command("XNPMAX", cmd_xnpmax);
Xchat::hook_command("XNPVOL", cmd_xnpvol);
Xchat::hook_command("XNPPLAY", cmd_xnpplay);
Xchat::hook_command ("XNPPAUSE", cmd_xnppause);
Xchat::hook_command ("XNPSTOP", cmd_xnpstop);
Xchat::hook_command ("XNPPREV", cmd_xnpprev);
Xchat::hook_command ("XNPNEXT", cmd_xnpnext);
Xchat::hook_command ("XNPRUN", cmd_xnprun);
Xchat::hook_command ("XNPQUIT", cmd_xnpquit);

Xchat::hook_command("XNP", cmd_xnp);
Xchat::hook_command("XNPS", cmd_xnps);
Xchat::hook_command("XNPSTATS", cmd_xnpstats);
Xchat::hook_command("XNPINFO", cmd_xnpinfo);
Xchat::hook_command("ALL_ON", cmd_all_on);
Xchat::hook_command("ALL_OFF", cmd_all_off);
Xchat::hook_command("XNPMODES", cmd_xnpmodes);
Xchat::hook_command("XNPHELP", cmd_xnphelp);
Xchat::hook_command("XNPABOUT", cmd_xnpabout);

Xchat::hook_command("XNPHOWTO", cmd_xnphowto);
Xchat::hook_command("XNPFAQ", cmd_xnpfaq);

load_messages();
load_integrity();
load_menus();

sub load_messages
{
	Xchat::print("---");
	Xchat::print("\cC02XNP:\cC01 XNP 0.8.4 by Craciun Dan loaded.");
	Xchat::print("\cC02XNP:\cC01 XChat Now Playing Script for Amarok is a Perl script that displays info about the currently playing track in Amarok and the music collection.");
	Xchat::print("\cC02XNP:\cC01 Type /XNP to use and /XNPHELP for a full list of commands.");
	Xchat::print("\cC02XNP:\cC01 For suggestions, feature requests and bug reports please contact me at floydian.embryo\@yahoo.com.");
	Xchat::print("---");
}

sub load_integrity
{
	if (integrity_check() == 1)
	{
		$openval = open(CONF, ">.xchat2/xnp.conf");
		if ($openval == 1)
		{
			print CONF "show_album=1\n";
			print CONF "show_year=1\n";
			print CONF "show_track=1\n";
			print CONF "show_length=1\n";
			print CONF "show_bitrate=1\n";
			print CONF "show_size=1\n";
			print CONF "show_menu=1\n";
			print CONF "browser=firefox\n";
			close(CONF);
			Xchat::print("\cC02XNP:\cC01 Created the XNP configuration file (~/.xchat2/xnp.conf) with default values.");
			return 0;
		}
		else
		{
			Xchat::print("\cC02XNP:\cC01 Could not read/create the XNP configuration file (~/.xchat2/xnp.conf). Please check disk space and file permissions.");
			Xchat::print("\cC02XNP:\cC01 Without the XNP configuration file, the /XNP command cannot work.");
			return 1;
		}
	}
	else
	{
		return 0;
	}
}

sub integrity_check
{
	$openval = open(CONF, ".xchat2/xnp.conf");
	if ($openval == 1)
	{
		$is_album = 0;
		$is_year = 0;
		$is_track = 0;
		$is_length = 0;
		$is_bitrate = 0;
		$is_size = 0;
		$is_menu = 0;
		$is_browser = 0;
		
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);

			if ($opt eq "show_album") { if ($is_album == 0) { $is_album = 1; } else { close(CONF); return 1; } }
			if ($opt eq "show_year") { if ($is_year == 0) { $is_year = 1; } else { close(CONF); return 1; } }
			if ($opt eq "show_track") { if ($is_track == 0) { $is_track = 1; } else { close(CONF); return 1; } }
			if ($opt eq "show_length") { if ($is_length == 0) { $is_length = 1; } else { close(CONF); return 1; } }
			if ($opt eq "show_bitrate") { if ($is_bitrate == 0) { $is_bitrate = 1; } else { close(CONF); return 1; } }
			if ($opt eq "show_size") { if ($is_size == 0) { $is_size = 1; } else { close(CONF); return 1; } }
			if ($opt eq "show_menu") { if ($is_menu == 0) { $is_menu = 1; } else { close(CONF); return 1; } }
			if ($opt eq "browser") { if ($is_browser == 0) { $is_browser = 1; } else { close(CONF); return 1; } }
			
			if ($opt ne "show_album" && $opt ne "show_year" && $opt ne "show_track" && $opt ne "show_length" &&
						    $opt ne "show_bitrate" && $opt ne "show_size" && $opt ne "show_menu" &&
						    $opt ne "browser")
			{
				close(CONF); return 1;
			}
			
			if ($opt ne "browser" && $val != 0 && $val != 1) { close(CONF); return 1; }
			if ($opt eq "browser")
			{
 				if ($val ne "firefox" && $val ne "epiphany" && $val ne "konqueror" && $val ne "opera") 
				{
					close(CONF); return 1;
				}
			}
		}
		
		if ($is_album == 1 && $is_year == 1 && $is_track == 1 && $is_length == 1 && $is_bitrate == 1 &&
		    $is_size == 1 && $is_menu == 1 && $is_browser == 1)
		{
			close(CONF); return 0;
		}
		else
		{
			close(CONF); return 1;
		}
	}
	else
	{
		return 1;
	}
}

sub load_menus
{
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);
			if ($opt eq "show_menu")
			{
				if ($val == 1)
				{
					Xchat::command("MENU DEL XNP");
					Xchat::command("MENU -p6 ADD XNP");
					Xchat::command ("MENU ADD \"XNP/Show\"");
					Xchat::command("MENU ADD \"XNP/Show/Standard\" \"XNP\"");
					Xchat::command("MENU ADD \"XNP/Show/Simple\" \"XNPS\"");
					Xchat::command("MENU ADD \"XNP/Show/Stats\" \"XNPSTATS\"");
					Xchat::command("MENU ADD \"XNP/Show/Info\" \"XNPINFO\"");
					Xchat::command("MENU ADD \"XNP/-\"");
					Xchat::command("MENU ADD \"XNP/Amarok\"");
					Xchat::command("MENU ADD \"XNP/-\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/Mute\" \"XNPMUTE\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/10%\" \"XNPVOL1\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/20%\" \"XNPVOL2\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/30%\" \"XNPVOL3\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/40%\" \"XNPVOL4\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/50%\" \"XNPVOL5\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/60%\" \"XNPVOL6\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/70%\" \"XNPVOL7\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/80%\" \"XNPVOL8\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/90%\" \"XNPVOL9\"");
					Xchat::command("MENU ADD \"XNP/Amarok/Volume/Max\" \"XNPMAX\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/-\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Play\" \"XNPPLAY\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Pause\" \"XNPPAUSE\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Stop\" \"XNPSTOP\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/-\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Prev\" \"XNPPREV\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Next\" \"XNPNEXT\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/-\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Start\" \"XNPRUN\"");
					Xchat::command ("MENU ADD \"XNP/Amarok/Quit\" \"XNPQUIT\"");
					Xchat::command("MENU ADD \"XNP/Toggle\"");
					Xchat::command("MENU ADD \"XNP/Toggle/Album\" \"TOGGLE_ALBUM\"");
					Xchat::command("MENU ADD \"XNP/Toggle/Year\" \"TOGGLE_YEAR\"");
					Xchat::command("MENU ADD \"XNP/Toggle/Track\" \"TOGGLE_TRACK\"");
					Xchat::command("MENU ADD \"XNP/Toggle/Length\" \"TOGGLE_LENGTH\"");
					Xchat::command("MENU ADD \"XNP/Toggle/Bitrate\" \"TOGGLE_BITRATE\"");
					Xchat::command("MENU ADD \"XNP/Toggle/Size\" \"TOGGLE_SIZE\"");
					Xchat::command("MENU ADD \"XNP/Set\"");
					Xchat::command("MENU ADD \"XNP/Set/All ON\" \"ALL_ON\"");
					Xchat::command("MENU ADD \"XNP/Set/All OFF\" \"ALL_OFF\"");
					Xchat::command("MENU ADD \"XNP/Set/-");
					Xchat::command("MENU ADD \"XNP/Set/Help Browser\"");
					Xchat::command("MENU ADD \"XNP/Set/Help Browser/Firefox\" \"BROWSER1\"");
					Xchat::command("MENU ADD \"XNP/Set/Help Browser/Epiphany\" \"BROWSER2\"");
					Xchat::command("MENU ADD \"XNP/Set/Help Browser/Konqueror\" \"BROWSER3\"");
					Xchat::command("MENU ADD \"XNP/Set/Help Browser/Opera\" \"BROWSER4\"");
					Xchat::command("MENU ADD \"XNP/View\"");
					Xchat::command("MENU ADD \"XNP/View/Modes\" \"XNPMODES\"");
					Xchat::command("MENU ADD \"XNP/View/-");
					Xchat::command("MENU ADD \"XNP/View/XNP How-To\" \"XNPHOWTO\"");
					Xchat::command("MENU ADD \"XNP/View/XNP FAQ\" \"XNPFAQ\"");
					Xchat::command("MENU ADD \"XNP/View/-");
					Xchat::command("MENU ADD \"XNP/View/Help\" \"XNPHELP\"");
					Xchat::command("MENU ADD \"XNP/-\"");
					Xchat::command("MENU ADD \"XNP/About\" \"XNPABOUT\"");
				}
			}
		}
		close(CONF);
	}
	return 0;
}

sub call_toggle_album
{
	cmds_toggle("show_album");
}
sub call_toggle_year
{
	cmds_toggle("show_year");
}
sub call_toggle_track
{
	cmds_toggle("show_track");
}
sub call_toggle_length
{
	cmds_toggle("show_length");
}
sub call_toggle_bitrate
{
	cmds_toggle("show_bitrate");
}
sub call_toggle_size
{
	cmds_toggle("show_size");
}
sub call_toggle_show_menu
{
	cmds_toggle("show_menu");
}
sub call_browser1
{
	cmd_browser("firefox");
}
sub call_browser2
{
	cmd_browser("epiphany");
}
sub call_browser3
{
	cmd_browser("konqueror");
}
sub call_browser4
{
	cmd_browser("opera");
}

sub cmds_toggle
{
	$toggle_opt = $_[0];
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		$i = 0;
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);
			
			if ($toggle_opt eq $opt)
			{
				if ($val == 1)
				{
					$ison = 1;
				}
				elsif ($val == 0)
				{
					$ison = 0;
				}
			}
			else
			{
				$hold[$i] = "$_";
				$i = $i + 1;
			}
		}
		
		close(CONF);
		
		$openval = open(CONF, ">.xchat2/xnp.conf");
		if ($ison == 1)
		{
			print CONF "$toggle_opt=0\n";
		}
		elsif ($ison == 0)
		{
			print CONF "$toggle_opt=1\n";
		}
		$total = $i;
		$i = 0;
		while ($i < $total)
		{
			print CONF "$hold[$i]";
			$i = $i + 1;
		}
		close(CONF);
	}
	if ($ison == 1)
	{
		if ($toggle_opt eq "show_menu")
		{ 
			Xchat::command("MENU DEL XNP");
		}
		Xchat::print("\cC02XNP:\cC01 \cB$toggle_opt\cB is now \cBOFF\cB.");
	}
	elsif ($ison == 0)
	{
		if ($toggle_opt eq "show_menu")
		{ 
			load_menus();
		}
		Xchat::print("\cC02XNP:\cC01 \cB$toggle_opt\cB is now \cBON\cB.");
	}	
	return Xchat::EAT_ALL;
}
sub cmd_xnpabout
{
	Xchat::command ("GUI MSGBOX \"XNP 0.8.4\n\nXChat Now Playing Script for Amarok 1.4\n\n(C) 2006-2009 Craciun Dan\n\nhttp://project-lsp.sourceforge.net/\"");
	return Xchat::EAT_ALL;
}

sub cmd_browser
{
	$browser_opt = $_[0];
	if (browser_installed("$browser_opt") == 0)
	{
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		
		$change = "false";
		$i = 0;
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);
			
			if ($opt eq "browser")
			{
				if ($val ne "$browser_opt")
				{
					$change = "true";
				}	
			}
			else
			{
				$hold[$i] = "$_";
				$i = $i + 1;
				$total = $i;
			}
		}
		close(CONF);
		if ($change eq "true")
		{
			$i = 0;
			$openval = open(CONF, ">.xchat2/xnp.conf");
			while ($i <= $total)
			{
				print CONF "$hold[$i]";
				$i = $i + 1;
			}
			print CONF "browser=$browser_opt\n";
			close(CONF);
			Xchat::print("\cC02XNP:\cC01 The help \cBbrowser\cB is now set to \cB$browser_opt\cB.");
		}
		else
		{
			Xchat::print("\cC02XNP:\cC01 The help \cBbrowser\cB is already set to \cB$browser_opt\cB.");
		}
	}
	}
	else
	{
		Xchat::print("\cC02XNP:\cC01 The \cB$browser_opt\cB browser is not installed. Install it or try another browser.");
		return Xchat::EAT_ALL;
	}
	return Xchat::EAT_ALL;
}
		
sub cmd_xnpmute
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 0)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already muted.");
		}
		else
		{
			system("dcop amarok default setVolume 0");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now muted.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpplay
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp ($isPlaying);
	if ($isPlaying ne "")
	{
		system ("dcop amarok default play");
	}
	if ($isPlaying eq "")
	{
		Xchat::print ("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnppause
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp ($isPlaying);
	if ($isPlaying ne "")
	{
		system ("dcop amarok default pause");
	}
	if ($isPlaying eq "")
	{
		Xchat::print ("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpstop
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp ($isPlaying);
	if ($isPlaying ne "")
	{
		system ("dcop amarok default stop");
	}
	if ($isPlaying eq "")
	{
		Xchat::print ("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpprev
{
	system ("dcop amarok default prev");
	return Xchat::EAT_ALL;
}

sub cmd_xnpnext
{
	system ("dcop amarok default next");
	return Xchat::EAT_ALL;
}

sub cmd_xnprun
{
	system ("amarok");
	return Xchat::EAT_ALL;
}

sub cmd_xnpquit
{
	system ("dcop amarok MainApplication-Interface quit");
	return Xchat::EAT_ALL;
}

sub cmd_xnpmax
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 100)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already maximum.");
		}
		else
		{
		system("dcop amarok default setVolume 100");
		Xchat::print("\cC02XNP:\cC01 Amarok volume is now maximum.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$val = $_[0][1];
		if ($val ne "")
		{
			$getVolume = `dcop amarok default getVolume`;
			chomp($getVolume);
			if ($getVolume == $val)
			{
				Xchat::print("\cC02XNP:\cC01 Amarok volume is already $val%.");
			}
			else
			{
				system("dcop amarok default setVolume $val");
				Xchat::print("\cC02XNP:\cC01 Amarok volume is now $val%.");
			}
		}
		else
		{
			Xchat::print("\cC02XNP:\cC01 Usage: /XNPVOL <VOLUME>");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol1
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 10)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 10%.");
		}
		else
		{
			system("dcop amarok default setVolume 10");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 10%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}
sub cmd_xnpvol2
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 20)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 20%.");
		}
		else
		{
			system("dcop amarok default setVolume 20");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 20%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol3
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 30)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 30%.");
		}
		else
		{
			system("dcop amarok default setVolume 30");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 30%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol4
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 40)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 40%.");
		}
		else
		{
			system("dcop amarok default setVolume 40");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 40%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol5
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 50)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 50%.");
		}
		else
		{
			system("dcop amarok default setVolume 50");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 50%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol6
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 60)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 60%.");
		}
		else
		{
			system("dcop amarok default setVolume 60");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 60%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}
sub cmd_xnpvol7
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 70)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 70%.");
		}
		else
		{
			system("dcop amarok default setVolume 70");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 70%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol8
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 80)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 80%.");
		}
		else
		{
			system("dcop amarok default setVolume 80");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 80%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpvol9
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$getVolume = `dcop amarok default getVolume`;
		chomp($getVolume);
		if ($getVolume == 90)
		{
			Xchat::print("\cC02XNP:\cC01 Amarok volume is already 90%.");
		}
		else
		{
			system("dcop amarok default setVolume 90");
			Xchat::print("\cC02XNP:\cC01 Amarok volume is now 90%.");
		}
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}
		
sub cmd_xnp
{
	if (load_integrity() == 0)
	{
		$isPlaying = `dcop amarok default isPlaying`;
		chomp($isPlaying);
		if ($isPlaying eq "true")
		{
			$openval = open(CONF, ".xchat2/xnp.conf");
			while (<CONF>)
			{
				@array = split("=", $_);
				$opt = $array[0];
				$val = $array[1];
				chomp($opt);
				chomp($val);
				if ($opt eq "show_album") { if ($val == 0) { $show_album = 0; } else { $show_album = 1; } }
				if ($opt eq "show_year") { if ($val == 0) { $show_year = 0; } else { $show_year = 1; } }
				if ($opt eq "show_track") { if ($val == 0) { $show_track = 0; } else { $show_track = 1; } }
				if ($opt eq "show_length") { if ($val == 0) { $show_length = 0; } else { $show_length = 1; } }
				if ($opt eq "show_bitrate") { if ($val == 0) { $show_bitrate = 0; } else { $show_bitrate = 1; } }
				if ($opt eq "show_size") { if ($val == 0) { $show_size = 0; } else { $show_size = 1; } }
			}
			close(CONF);
			
			$tmp_title = `dcop amarok default title`;
			$tmp_artist = `dcop amarok default artist`;
			
			chomp($tmp_title);
			chomp($tmp_artist);
			if ($tmp_title eq "" && $tmp_artist eq "")
			{
				$tmp_filename = filename();
				$artist = "";
				$title = "\cC02$tmp_filename\cC01 ";
			}
			else
			{
				if ($tmp_title eq "")
				{
					$title = "(\cC02No Title Field\cC01) ";
					$artist = "\cC01by \cC02$tmp_artist\cC01 ";
				}
				if ($tmp_artist eq "")
				{
					$title = "\cC02$tmp_title\cC01 by ";
					$artist = "\cC02(No Artist Field)";
				}
			}
			if ($tmp_title ne "" && $tmp_artist ne "")
			{
				$title = "\cC02$tmp_title\cC01 by ";
				$artist = "\cC02$tmp_artist\cC01 ";
			}
			
			if ($show_album == 1)
			{
				$tmp_album = `dcop amarok default album`;
				chomp($tmp_album);
				if ($tmp_album ne "")
				{
					$album = "\cC01on \cC02$tmp_album\cC01 ";
				}
				else
				{
					$album = "\cC01on \cC02(No Album Field)\cC01 ";
				}
			}
			else
			{
				$album = "";
			}
			if ($show_year == 1)
			{
				$tmp_year = `dcop amarok default year`;
				chomp($tmp_year);
				if ($tmp_year != 0)
				{
					$year = "\cC01[Year: \cC03$tmp_year\cC01] ";
				}
				else
				{
					$year = "\cC01[Year: \cC03(No Year Field)\cC01] ";
				}
			} 
			else 
			{ 
				$year = "";
			}
			if ($show_track == 1)
			{
				$tmp_track = `dcop amarok default track`;
				chomp($tmp_track);
				if ($tmp_track != 0)
				{
					$track = "\cC01[Track: \cC03$tmp_track\cC01] ";
				}
				else
				{
					$track = "\cC01[Track: \cC03(No Track Field)\cC01] ";
				}
			}
			else
			{
				$track = "";
			}
			if ($show_length == 1)
			{
				$tmp_length = `dcop amarok default totalTime`;
				chop($tmp_length);
				if ($tmp_length ne "")
				{
					$length = "\cC01[Length: \cC03$tmp_length\cC01] ";
				}
				else
				{
					$length = "\cC01[Length: \cC03(No Length Field)\cC01] ";
				}
			}
			else
			{
				$length = "";
			}
			if ($show_bitrate == 1)
			{
				$tmp_bitrate = `dcop amarok default bitrate`;
				chomp($tmp_bitrate);
				if ($tmp_bitrate ne "")
				{
					$bitrate = "\cC01[Bitrate: \cC03$tmp_bitrate\cC01] ";
				}
				else
				{
					$bitrate = "\cC01[Bitrate: \cC03(No Bitrate Field)\cC01] ";
				}
			}
			else
			{
				$bitrate = "";
			}
			if ($show_size == 1)
			{
				$tmp_size = filesize();
				$size = "\cC01[Size: \cC03$tmp_size\cC01] ";
			}
			else
			{
				$size = "";
			}
			
			$line_xnp = "\cC01Rocks! $title$artist$album$year$track$length$bitrate$size";
			Xchat::command("SAY $line_xnp");
		}
		if ($isPlaying eq "false")
		{
			Xchat::print("\cC02XNP:\cC01 Amarok is either stopped or paused.");
		}
		if ($isPlaying eq "")
		{
			Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
		}
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnps
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying eq "true")
	{
		$nowPlaying = `dcop amarok default nowPlaying`;
		chomp($nowPlaying);
		$line_xnps = "\cC01Rocks! \cC02$nowPlaying\cC01";
		Xchat::command("SAY $line_xnps");
	}
	if ($isPlaying eq "false")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is either stopped or paused.");
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpstats
{
	$isPlaying = `dcop amarok default isPlaying`;
	chomp($isPlaying);
	if ($isPlaying ne "")
	{
		$totalAlbums = `dcop amarok collection totalAlbums`;
		$totalArtists = `dcop amarok collection totalArtists`;
		$totalCompilations = `dcop amarok collection totalCompilations`;
		$totalGenres = `dcop amarok collection totalGenres`;
		$totalTracks = `dcop amarok collection totalTracks`;
		chomp($totalAlbums);
		chomp($totalArtists);
		chomp($totalCompilations);
		chomp($totalGenres);
		chomp($totalTracks);
		$line_xnpstats = "\cC01Amarok Collection: [Tracks: \cC03$totalTracks\cC01] [Artists: \cC03$totalArtists\cC01] [Albums: \cC03$totalAlbums\cC01] [Compilations: \cC03$totalCompilations\cC01] [Genres: \cC03$totalGenres\cC01] ";
		Xchat::command("SAY $line_xnpstats");
	}
	else
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpinfo
{
	$isPlaying = `dcop amarok default isPlaying`;
	
	chomp($isPlaying);
	
	$totalAlbums = `dcop amarok collection totalAlbums`;
	$totalArtists = `dcop amarok collection totalArtists`;
	$totalCompilations = `dcop amarok collection totalCompilations`;
	$totalGenres = `dcop amarok collection totalGenres`;
	$totalTracks = `dcop amarok collection totalTracks`;
	
	chomp($totalAlbums);
	chomp($totalArtists);
	chomp($totalCompilations);
	chomp($totalGenres);
	chomp($totalTracks);
	
	if ($isPlaying eq "true")
	{
		$tmp_title = `dcop amarok default title`;
		$tmp_artist = `dcop amarok default artist`;
			
		chomp($tmp_title);
		chomp($tmp_artist);
		
		if ($tmp_title eq "" && $tmp_artist eq "")
		{
			$tmp_filename = filename();
			$artist = "\cC02(No Title Field)\cC01";
			$title = "\cC02$tmp_filename\cC01 ";
		}
		else
		{
			if ($tmp_title eq "")
			{
				$title = "\cC02(No Title Field\cC01) ";
				$artist = "\cC02$tmp_artist\cC01";
			}
			if ($tmp_artist eq "")
			{
				$title = "\cC02$tmp_title\cC01";
				$artist = "\cC02(No Artist Field)";
			}
		}
		if ($tmp_title ne "" && $tmp_artist ne "")
		{
			$title = "\cC02$tmp_title\cC01";
			$artist = "\cC02$tmp_artist\cC01";
		}
		$tmp_album = `dcop amarok default album`;
		chomp($tmp_album);
		if ($tmp_album ne "")
		{
			$album = "\cC02$tmp_album\cC01";
		}
		else
		{
			$album = "\cC02(No Album Field)\cC01";
		}
		$tmp_year = `dcop amarok default year`;
		chomp($tmp_year);
		if ($tmp_year != 0)
		{
			$year = "\cC03$tmp_year\cC01";
		}
		else
		{
			$year = "\cC03(No Year Field)\cC01";
		}
		$tmp_track = `dcop amarok default track`;
		chomp($tmp_track);
		if ($tmp_track != 0)
		{
			$track = "\cC03$tmp_track\cC01";
		}
		else
		{
			$track = "\cC03(No Track Field)\cC01";
		}
		$tmp_length = `dcop amarok default totalTime`;
		chop($tmp_length);
		if ($tmp_length ne "")
		{
			$length = "\cC03$tmp_length\cC01";
		}
		else
		{
			$length = "\cC03(No Length Field)\cC01";
		}

		$tmp_bitrate = `dcop amarok default bitrate`;
		chomp($tmp_bitrate);
		if ($tmp_bitrate ne "")
		{
			$bitrate = "\cC03$tmp_bitrate\cC01";
		}
		else
		{
			$bitrate = "\cC03(No Bitrate Field)\cC01";
		}
		$tmp_size = filesize();
		$size = "\cC03$tmp_size\cC01";
		
		Xchat::print("---");
		Xchat::print("\cC02XNP:\cC01 \cBRocks!\cB");
		Xchat::print("\cC02XNP:\cC01 Title:   \cC02$title");
		Xchat::print("\cC02XNP:\cC01 Artist:  \cC02$artist");
		Xchat::print("\cC02XNP:\cC01 Album:   \cC02$album");
		Xchat::print("\cC02XNP:\cC01 Year:    \cC03$year");
		Xchat::print("\cC02XNP:\cC01 Track:   \cC03$track");
		Xchat::print("\cC02XNP:\cC01 Length:  \cC03$length");
		Xchat::print("\cC02XNP:\cC01 Bitrate: \cC03$bitrate");
		Xchat::print("\cC02XNP:\cC01 Size:    \cC03$size");
		Xchat::print("\cC02XNP:\cC01 \cBAmarok Collection:\cB");
		Xchat::print("\cC02XNP:\cC01 Tracks:       \cC03$totalTracks");
		Xchat::print("\cC02XNP:\cC01 Artists:      \cC03$totalArtists");
		Xchat::print("\cC02XNP:\cC01 Albums:       \cC03$totalAlbums");
		Xchat::print("\cC02XNP:\cC01 Compilations: \cC03$totalCompilations");
		Xchat::print("\cC02XNP:\cC01 Genres:       \cC03$totalGenres");
		Xchat::print("---");
	}
	if ($isPlaying eq "false")
	{
		Xchat::print("---");
		Xchat::print("\cC02XNP:\cC01 Amarok is either stopped or paused.");
		Xchat::print("\cC02XNP:\cC01 \cBAmarok Collection:\cB");
		Xchat::print("\cC02XNP:\cC01 Tracks:       \cC03$totalTracks");
		Xchat::print("\cC02XNP:\cC01 Artists:      \cC03$totalArtists");
		Xchat::print("\cC02XNP:\cC01 Albums:       \cC03$totalAlbums");
		Xchat::print("\cC02XNP:\cC01 Compilations: \cC03$totalCompilations");
		Xchat::print("\cC02XNP:\cC01 Genres:       \cC03$totalGenres");
		Xchat::print("---");
	}
	if ($isPlaying eq "")
	{
		Xchat::print("\cC02XNP:\cC01 Amarok is not running.");
	}
	return Xchat::EAT_ALL;
}

sub cmd_all_on
{
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		$allon = 1;
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($val);
			if ($opt ne "browser" && $opt ne "show_menu" && $val == 0)
			{
				$allon = 0;
			}
			if ($opt eq "show_menu" && $val == 0)
			{
				$menu = 0;
			}
			if ($opt eq "show_menu" && $val == 1)
			{
				$menu = 1;
			}
			if ($opt eq "browser")
			{
				$browser = $val;
			}
		}
		close(CONF);
		if ($allon == 0)
		{
			$openval = open(CONF, ">.xchat2/xnp.conf");
			print CONF "show_album=1\n";
			print CONF "show_year=1\n";
			print CONF "show_track=1\n";
			print CONF "show_length=1\n";
			print CONF "show_bitrate=1\n";
			print CONF "show_size=1\n";
			print CONF "show_menu=$menu\n";
			print CONF "browser=$browser\n";
			close(CONF);
			Xchat::print("\cC02XNP:\cC01 Displaying all the info is now \cBON\cB.");
		}
		elsif ($allon == 1)
		{
			Xchat::print("\cC02XNP:\cC01 Displaying all the info is already \cBON\cB.");
		}
	}
	return Xchat::EAT_ALL;
}

sub cmd_all_off
{
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		$allon = 0;
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);
			if ($opt ne "show_menu" && $opt ne "browser" && $val == 1)
			{
				$allon = 1;
			}
			if ($opt eq "show_menu" && $val == 0)
			{
				$menu = 0;
			}
			if ($opt eq "show_menu" && $val == 1)
			{
				$menu = 1;
			}
			if ($opt eq "browser")
			{
				$browser = $val;
			}
		}
		close(CONF);
		if ($allon == 1)
		{
			$openval = open(CONF, ">.xchat2/xnp.conf");
			print CONF "show_album=0\n";
			print CONF "show_year=0\n";
			print CONF "show_track=0\n";
			print CONF "show_length=0\n";
			print CONF "show_bitrate=0\n";
			print CONF "show_size=0\n";
			print CONF "show_menu=$menu\n";
			print CONF "browser=$browser\n";
			close(CONF);
			Xchat::print("\cC02XNP:\cC01 Displaying all the info is now \cBOFF\cB.");
		}
		elsif ($allon == 0)
		{
			Xchat::print("\cC02XNP:\cC01 Displaying all the info is already \cBOFF\cB.");
		}
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpmodes
{
	if (load_integrity() == 0)
	{
		Xchat::print("---");
		Xchat::print("\cC02XNP:\cC01\cB XNP Modes\cB");
		$openval = open(CONF, ".xchat2/xnp.conf");
		while (<CONF>)
		{
			chomp($_);
			Xchat::print("\cC02XNP:\cC01 $_");
		}
		close(CONF);
		Xchat::print("---");
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnphowto
{
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);
			if ($opt eq "browser")
			{
				if (browser_installed($val) == 0)
				{
					Xchat::command("EXEC $val ~/.xchat2/xnp-help/howto-xnp.html");
					return Xchat::EAT_ALL;
				}
				else
				{
					Xchat::print("\cC02XNP:\cC01 The \cB$browser_opt\cB browser is not installed.");
					if ($val ne "firefox")
					{
						$cmd_browser = `firefox --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER1");
							Xchat::command("EXEC firefox ~/.xchat2/xnp-help/howto-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					if ($val ne "epiphany")
					{
						$cmd_browser = `epiphany --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER2");
							Xchat::command("EXEC epiphany ~/.xchat2/xnp-help/howto-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					if ($val ne "konqueror")
					{
						$cmd_browser = `konqueror --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER3");
							Xchat::command("EXEC konqueror ~/.xchat2/xnp-help/howto-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					if ($val ne "opera")
					{
						$cmd_browser = `opera --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER4");
							Xchat::command("EXEC opera ~/.xchat2/xnp-help/howto-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					return Xchat::EAT_ALL;
				}
			}
		}
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnpfaq
{
	if (load_integrity() == 0)
	{
		$openval = open(CONF, ".xchat2/xnp.conf");
		while (<CONF>)
		{
			@array = split("=", $_);
			$opt = $array[0];
			$val = $array[1];
			chomp($opt);
			chomp($val);
			if ($opt eq "browser")
			{
				if (browser_installed($val) == 0)
				{
					Xchat::command("EXEC $val ~/.xchat2/xnp-help/faq-xnp.html");
					return Xchat::EAT_ALL;
				}
				else
				{
					Xchat::print("\cC02XNP:\cC01 The \cB$browser_opt\cB browser is not installed.");
					if ($val ne "firefox")
					{
						$cmd_browser = `firefox --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER1");
							Xchat::command("EXEC firefox ~/.xchat2/xnp-help/faq-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					if ($val ne "epiphany")
					{
						$cmd_browser = `epiphany --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER2");
							Xchat::command("EXEC epiphany ~/.xchat2/xnp-help/faq-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					if ($val ne "konqueror")
					{
						$cmd_browser = `konqueror --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER3");
							Xchat::command("EXEC konqueror ~/.xchat2/xnp-help/faq-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
					if ($val ne "opera")
					{
						$cmd_browser = `opera --version`;
						if ($cmd_browser ne "")
						{
							Xchat::command("BROWSER4");
							Xchat::command("EXEC opera ~/.xchat2/xnp-help/faq-xnp.html");
							return Xchat::EAT_ALL;
						}
					}
				}
			}
		}
	}
	return Xchat::EAT_ALL;
}

sub cmd_xnphelp
{
	$arg = $_[0][1];
	if ($arg eq "")
	{
	Xchat::print("---");
	Xchat::print("\cC02XNP:\cC01 \cBXNP 0.8.4\cB - \cBX\cBChat \cBN\cBow \cBP\cBlaying Script for Amarok 1.4");
	Xchat::print("\cC02XNP:\cC01 -");
	Xchat::print("\cC02XNP:\cC01 /XNP              /XNPS          /XNPSTATS            /XNPINFO");
	Xchat::print("\cC02XNP:\cC01 /TOGGLE_ALBUM     /TOGGLE_YEAR   /TOGGLE_TRACK        /TOGGLE_LENGTH");
	Xchat::print("\cC02XNP:\cC01 /TOGGLE_BITRATE   /TOGGLE_SIZE   /TOGGLE_SHOW_MENU    /ALL_ON          /ALL_OFF");
	Xchat::print("\cC02XNP:\cC01 /BROWSER1         /BROWSER2      /BROWSER3            /BROWSER4");
	Xchat::print("\cC02XNP:\cC01 /XNPHOWTO         /XNPFAQ");
	Xchat::print("\cC02XNP:\cC01 /XNPMUTE          /XNPMAX        /XNPVOL <VOLUME>     /XNPVOL1         /XNPVOL2");
	Xchat::print("\cC02XNP:\cC01 /XNPVOL3          /XNPVOL4       /XNPVOL5             /XNPVOL6         /XNPVOL7");
	Xchat::print("\cC02XNP:\cC01 /XNPVOL8          /XNPVOL9       /XNPRUN              /XNPQUIT");
	Xchat::print("\cC02XNP:\cC01 /XNPPLAY          /XNPPAUSE      /XNPSTOP             /XNPPREV          /XNPNEXT");
	Xchat::print("\cC02XNP:\cC01 /XNPMODES         /XNPABOUT      /XNPHELP [COMMAND]");
	Xchat::print("\cC02XNP:\cC01 Type /XNPHELP COMMAND to see detailed help on each command.");
	Xchat::print("\cC02XNP:\cC01 -");
	Xchat::print("\cC02XNP:\cC01 Please visit Project LSP's homepage: http://project-lsp.sourceforge.net/scripts.html");
	Xchat::print("\cC02XNP:\cC01 To load this script when XChat starts, copy the xnp.pl file into your ~/.xchat2 directory.");
	Xchat::print("\cC02XNP:\cC01 For suggestions, feature requests and bug reports please contact me at floydian.embryo\@yahoo.com.");
	Xchat::print("---");
	}
	if (lc($arg) eq "xnp")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB message the current channel/query");
	}
	if (lc($arg) eq "xnps")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB message the current channel/query in a very simplistic format");
	}
	if (lc($arg) eq "xnpstats")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB message the current channel/query info about the Amarok collection");
	}
	if (lc($arg) eq "xnpinfo")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB echo in the current window info about the current playing track and collection");
	}
	if (lc($arg) eq "toggle_album")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle displaying the album");
	}
	if (lc($arg) eq "toggle_year")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle displaying the year");
	}
	if (lc($arg) eq "toggle_track")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle displaying the track");
	}
	if (lc($arg) eq "toggle_length")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle displaying the length");
	}
	if (lc($arg) eq "toggle_bitrate")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle displaying the bitrate");
	}
	if (lc($arg) eq "toggle_size")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle displaying the size");
	}
	if (lc($arg) eq "toggle_show_menu")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle the XNP menu ON/OFF");
	}
	if (lc($arg) eq "all_on")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle ON displaying all the info");
	}
	if (lc($arg) eq "all_off")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB toggle OFF displaying all the info");
	}
	if (lc($arg) eq "browser1")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change the help browser to Firefox");
	}
	if (lc($arg) eq "browser2")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change the help browser to Epiphany");
	}
	if (lc($arg) eq "browser3")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change the help browser to Konqueror");
	}
	if (lc($arg) eq "browser4")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change the help browser to Opera");
	}
	if (lc($arg) eq "xnphowto")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB open the XNP How-To");
	}
	if (lc($arg) eq "xnpfaq")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB open the XNP FAQ");
	}
	if (lc($arg) eq "xnpvol")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to any value (ie. /XNPVOL 73)");
	}
	if (lc($arg) eq "xnpmute")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB mute Amarok");
	}
	if (lc($arg) eq "xnpmax")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to maximum (100%)");
	}
	if (lc($arg) eq "xnpvol1")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 10%");
	}
	if (lc($arg) eq "xnpvol2")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 20%");
	}
	if (lc($arg) eq "xnpvol3")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 30%");
	}
	if (lc($arg) eq "xnpvol4")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 40%");
	}
	if (lc($arg) eq "xnpvol5")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 50%");
	}
	if (lc($arg) eq "xnpvol6")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 60%");
	}
	if (lc($arg) eq "xnpvol7")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 70%");
	}
	if (lc($arg) eq "xnpvol8")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 80%");
	}
	if (lc($arg) eq "xnpvol9")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB change Amarok volume to 90%");
	}
	if (lc($arg) eq "xnpmodes")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB echo in the current window which info are ON and which are OFF");
	}
	if (lc($arg) eq "xnphelp")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB get a list of commands or help on a specific command (ie. /XNPHELP XNP)");
	}
	if (lc($arg) eq "xnpabout")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB show the about message box");
	}
	if (lc($arg) eq "xnpplay")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB start playing a track in Amarok");
	}
	if (lc($arg) eq "xnppause")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB pause Amarok");
	}
	if (lc($arg) eq "xnpstop")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB stop Amarok");
	}
	if (lc($arg) eq "xnpprev")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB select/play previous track in Amarok");
	}
	if (lc($arg) eq "xnpnext")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB select/play next track in Amarok");
	}
	if (lc($arg) eq "xnprun")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB run Amarok");
	}
	if (lc($arg) eq "xnpquit")
	{
		Xchat::print("\cC02XNP:\cC01 \cB/XNP\cB quit Amarok");
	}
	return Xchat::EAT_ALL;
}

sub filesize
{
	$path = `dcop amarok default path`;
	chomp($path);
	@array_tmp = split("/", $path);
	$len = @array_tmp;
	$ls = `ls -l \"$path\"`;
	@array = split(" ", $ls);
	$size_bytes = $array[4];
	$size_kb = $size_bytes/1024;
	$size_mb = $size_bytes/(1024*1024);
	if ($size_mb < 0.01)
	{
		if ($size_kb < 0.01)
		{
			$size_bytes = substr($size_bytes, 0, 4);
			return "$size_bytes \cC01Bytes";
		}
		if ($size_kb >= 0.01)
		{
			$size_kb = substr($size_kb, 0, 4);
			return "$size_kb \cC01KB";
		}
	}
	if ($size_mb >= 0.01)
	{
		if ($size_mb >= 10)
		{
			$size_mb = substr($size_mb, 0, 5);
		}
		else
		{
			$size_mb = substr($size_mb, 0, 4);
		}
		return "$size_mb \cC01MB";
	}
}

sub filename
{
	$path = `dcop amarok default path`;
	chomp($path);
	@array_tmp = split("/", $path);
	$len = @array_tmp;
	$filename = $array_tmp[$len - 1];
	return $filename;
}

sub browser_installed
{
	$browser_opt = $_[0];
	$cmd_output = `$browser_opt --version`;
	chomp($cmd_output);
	if ($cmd_output ne "")
	{
		return 0;
	}
	else
	{
		return 1;
	}
	return 1;
}